=== debian/changelog ===
mgba (0.5.2+dfsg1-3) unstable; urgency=medium

  * Team upload.
  * Add gcc7.patch and fix FTBFS with GCC 7. (Closes: #853546)
    Thanks to Adrian Bunk for the patch.
  * Declare compliance with Debian Policy 4.0.1.
  * Switch to compat level 10.
  * Use https for Format field.

 -- Markus Koschany <apo@debian.org>  Thu, 17 Aug 2017 21:39:12 +0200

mgba (0.5.2+dfsg1-2) unstable; urgency=low

  * Fix GB/GBC saves in the Libretro port.

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Wed, 04 Jan 2017 23:38:00 -0300

mgba (0.5.2+dfsg1-1) unstable; urgency=low

  * New upstream release.

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sat, 31 Dec 2016 18:35:00 -0300
