=== debian/watch ===
version=3
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$// \
  https://github.com/mgba-emu/mgba/tags .*/v?(\d\S*)\.tar\.gz
